// ctrlWindow.cpp : implementation file
//

#include "stdafx.h"
#include "control.h"
#include "ctrlWindow.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_REGISTER_WINDOW( CctrlWindow, CS_GLOBALCLASS, 0, LoadCursor(NULL, IDC_ARROW), 0 )

CctrlWindow::CctrlWindow() :
   m_bLeftButtonDown(FALSE)
{
   //m_ptrarrayToPoint.SetSize( 50 );
}

CctrlWindow::~CctrlWindow()
{
   Empty();
}

void CctrlWindow::AddPoint( const POINT* pPoint )
{
   POINT* ppointStore = new POINT;

   ppointStore->x = pPoint->x;
   ppointStore->y = pPoint->y;

   m_ptrarrayToPoint.Add( ppointStore );
}

void CctrlWindow::Empty()
{
   int iIndex;

   iIndex = m_ptrarrayToPoint.GetSize();
   while( iIndex )
   {
      iIndex--;
      delete m_ptrarrayToPoint[iIndex];
   }
   m_ptrarrayToPoint.RemoveAll();
}


BEGIN_MESSAGE_MAP(CctrlWindow, CWnd)
	//{{AFX_MSG_MAP(CctrlWindow)
	ON_WM_PAINT()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CctrlWindow message handlers

void CctrlWindow::OnPaint() 
{
   int    iIndex;
   POINT* pPoint;

   if( m_ptrarrayToPoint.GetSize() == 0 ) return;

   CPaintDC dc(this); 

   iIndex = m_ptrarrayToPoint.GetSize() - 1;
   pPoint = (POINT*)m_ptrarrayToPoint[iIndex];
   dc.MoveTo( *pPoint );
   while( iIndex )
   {
      iIndex--;
      pPoint = (POINT*)m_ptrarrayToPoint[iIndex];
      dc.LineTo( *pPoint );
   }
}

void CctrlWindow::OnLButtonDown(UINT nFlags, CPoint point) 
{
   Empty();
   Invalidate();
	SetCapture();
   m_bLeftButtonDown = TRUE;

   AddPoint( &point );
	
	CWnd::OnLButtonDown(nFlags, point);
}

void CctrlWindow::OnLButtonUp(UINT nFlags, CPoint point) 
{
   if( m_bLeftButtonDown )
   {
      ReleaseCapture();
      m_bLeftButtonDown = FALSE;
   }
	
   CWnd::OnLButtonUp(nFlags, point);
}

void CctrlWindow::OnMouseMove(UINT nFlags, CPoint point) 
{
   POINT* pPoint;

   if( m_bLeftButtonDown )
   {
      CClientDC dc(this);

      pPoint = (POINT*)m_ptrarrayToPoint[m_ptrarrayToPoint.GetUpperBound()];

      dc.MoveTo( *pPoint );
      dc.LineTo( point );
      AddPoint( &point );
   }
   
	CWnd::OnMouseMove(nFlags, point);
}


